/*
 * lab1.c
 */

#include "lcd.h"
#include "rtc.h"

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define ON "ON"
#define OFF "OFF"

int main()
{	
	LCD_init();
	RTC_Init();
	
	rtc_t rtc;
   
	char buffer[16];
	char alarm_buffer[16];
	char alarm_state[3];
	unsigned int alarm = 0;
	int alarm_hour_units = 0;
	int alarm_hour_zec = 0;
	int alarm_minute_units = 0;
	int alarm_minute_zec = 0;
	
	RTC_GetDateTime(&rtc);
	
	if(rtc.hour == 0x00 && rtc.min == 0x00 && rtc.sec == 0x00){
		rtc.hour = 0x19; //  10:40:20 am ora actuala
		rtc.min =  0x58;
		rtc.sec =  0x10;
		RTC_SetDateTime(&rtc);
	}
	
	/* Setez pinii PB2, PB3, PB5 ca intrare. */
	DDRB &= ~(1 << PB2);
	
	DDRB &= ~(1 << PB3);
	
	DDRB &= ~(1 << PB5);
	
	/* Activez rezistenta de pull-up pentru pinii PB3, PB2, PB5. */
	PORTB |= (1 << PB2);
	
	PORTB |= (1 << PB3);
	
	PORTB |= (1 << PB5);
	
	/* Setez pinul PD4 ca iesire. */
	DDRB |= (1 << PB4);

	/* Opresc speaker-ul. */
	PORTB &= ~(1 << PB4);
	
	while(1){
		RTC_GetDateTime(&rtc);
		sprintf(buffer, "time:%2x:%2x:%2x", (uint16_t)rtc.hour,(uint16_t)rtc.min,(uint16_t)rtc.sec);

		LCD_printAt(0x00, buffer);
	
		if((PINB & (1 << PB2)) == 0){
			if(alarm == 1)
				alarm = 0;
			else
				alarm = 1;
			_delay_ms(1000);
		}
		
		if((PINB & (1 << PB3)) == 0){
			alarm_minute_units++;
			
			if(alarm_minute_units == 10){
				alarm_minute_units = 0;
				alarm_minute_zec++;
			}
			
			if(alarm_minute_zec == 6){
				alarm_minute_zec = 0;
				alarm_hour_units++;
				
				if(alarm_hour_units == 4 && alarm_hour_zec == 2){
					alarm_hour_units = 0;
					alarm_hour_zec = 0;
				}
				else if(alarm_hour_units == 10){
					alarm_hour_units = 0;
					alarm_hour_zec++;
				}
			}
			
			_delay_ms(500);
		}
		
		if((PINB & (1 << PB5)) == 0){
			alarm_hour_units++;
			
			if(alarm_hour_units == 4 && alarm_hour_zec == 2){
				alarm_hour_units = 0;
				alarm_hour_zec = 0;
			}
			else if(alarm_hour_units == 10){
				alarm_hour_units = 0;
				alarm_hour_zec++;
			}
			
			_delay_ms(500);
		}
		
		if(alarm)
			strcpy(alarm_state, "ON");
		else
			strcpy(alarm_state, "OFF");
			
		sprintf(alarm_buffer,
			"alm:%s %d%d:%d%d",
			alarm_state,
			alarm_hour_zec, alarm_hour_units,
			alarm_minute_zec, alarm_minute_units);
			
		LCD_printAt(0xc0, alarm_buffer);
		LCD_putChar(' ');
		
		if(alarm == 1){
			PORTB |= (1 << PB4);
			_delay_ms(100);
			PORTB &= ~(1 << PB4); 
			_delay_ms(100);
		
		}
		else{
			PORTB |= (1 << PB4);
		}
		
	}

    return 0;
}

